set -gx FZF_DEFAULT_OPTS "
--layout=default
--border
--color=hl:#933737
--color=fg:#a7a7a7
--color=fg+:#d5d5d5
--color=bg:#121212
--color=bg+:#323232
--color=hl:#C4693D
--color=hl+:#E49A44
--color=info:#a7a7a7
--color=marker:#C4693D
--color=prompt:#C4693D
--color=spinner:#D87C4A
--color=pointer:#E5A72A
--color=header:#B14242
--color=border:#a7a7a7
--color=query:#d5d5d5
--color=gutter:#121212"

set -gx FZF_DEFAULT_COMMAND "fd --hidden --strip-cwd-prefix --exclude .git --exclude .anaconda --exclude .cache --exclude .conda --exclude .cmake --exclude '.dart*' --exclude '.git*' --exclude .java --exclude .librewolf --exclude .pub-cache --exclude .opm"
set -gx FZF_CTRL_T_COMMAND $FZF_DEFAULT_COMMAND
set -gx FZF_ALT_C_COMMAND "fd --type=d --hidden --strip-cwd-prefix --exclude .git --exclude .anaconda --exclude .cache --exclude .conda --exclude .cmake --exclude '.dart*' --exclude '.git*' --exclude .java --exclude .librewolf --exclude .pub-cache --exclude .opm"
set -gx export FZF_CTRL_R_OPTS "
  --reverse
  --cycle
  --info=right
  --color header:italic
  --header 'alt+s (pet new)'
  --preview 'echo {}' --preview-window down:3:hidden:wrap 
  --bind '?:toggle-preview'"
# --bind 'alt-s:execute(pet new --tag {2..})+abort'"
set -gx FZF_CTRL_T_OPTS "--preview 'bat --color=always -n --line-range :500 {}'"
set -gx FZF_ALT_C_OPTS "--preview 'eza --tree --color=always {} | head -200'"
