# this is for bootstrapping all external dependencies of my kakoune setup

# installs:
# fish
# ripgrep
# fd
# lua
# luajit
# kak-tree-sitter
# ktsctl
# hop-kak
# kakoune-lsp
# kak-popup
# aspell
# aspell-en
# bundle

define-command -hidden install-bundle %{
    info %sh{
        mkdir -p "$kak_config/bundle"
        git clone https://codeberg.org/jdugan6240/kak-bundle "$kak_config/bundle/kak-bundle" >/dev/null 2>&1
        echo "Restart kakoune and run bundle-install"
    }
}

define-command -hidden install-pacman %{
    terminal sh sudo pacman -Syu fish ripgrep fd lua luajit kakoune-lsp aspell aspell-en
}

define-command -hidden install-cargo %{
    terminal sh %{
        cargo install kak-tree-sitter;
        cargo install ktsctl;
        cargo install hop-kak;
        cargo install kak-popup
    }
}

define-command -docstring %{
    Bootstrap external dependencies of this configuration.
} bootstrap %{
    install-bundle
    install-pacman
    install-cargo
}
