require("custom-shell"):setup({
  history_path = "default",
  save_history = true,
})
require("git"):setup()
-- require("starship"):setup()

local bookmarks = {}

local home = os.getenv("HOME")
table.insert(bookmarks, {
  tag = "Documents",
  path = home .. "/Documents/",
  key = "d"
})
table.insert(bookmarks, {
  tag = "SyncDocuments",
  path = home .. "/SyncDocuments/",
  key = "s"
})
table.insert(bookmarks, {
  tag = "Pictures",
  path = home .. "/Pictures/",
  key = "p"
})
table.insert(bookmarks, {
  tag = "Downloads",
  path = home .. "/Downloads/",
  key = "D"
})
table.insert(bookmarks, {
  tag = "Videos",
  path = home .. "/Videos/",
  key = "v"
})

require("yamb"):setup({
  bookmarks = bookmarks,
  jump_notify = true,
  cli = "fzf",
  keys = "tnseriplfuwydhcxoaqz",
  path = home .. "/.config/yazi/bookmark",
})
